searchNodes=[{"doc":"Namespace only and exposing version","ref":"ExAequo.html","title":"ExAequo","type":"module"},{"doc":"Used by the xtra mix task to generate the latest version in the docs, but also handy for client applications for quick exploration in iex .","ref":"ExAequo.html#version/0","title":"ExAequo.version/0","type":"function"},{"doc":"ExAequo.Enum offers some extension functions for Elixir's Enum module Grouped Accumulation Groupes accumulated values of an Enum according to a function that indicates if two consequent items are of the same kind and if so how to accumulate their two values. The grouped_reduce function returns the groupes in reverse order, as, during traversal of lists quite often reversing the result of the classical &quot;take first and push a function of it to the result&quot; pattern cancels out. An optional, reverse: true keyword option can be provided to reverse the final result for convenience. iex(0)&gt; add_same = fn { x , a } , { y , b } -&gt; ...(0)&gt; cond do ...(0)&gt; x == y -&gt; { :cont , { x , a + b } } ...(0)&gt; true -&gt; { :stop , nil } end end ...(0)&gt; E . grouped_reduce ( ...(0)&gt; [ { :a , 1 } , { :a , 2 } , { :b , 3 } , { :b , 4 } ] , add_same ) [ { :b , 7 } , { :a , 3 } ] The grouped_inject function behaves almost identically to grouped_reduce , however an initial value is provided. iex(1)&gt; sub_same = fn { x , a } , { y , b } -&gt; ... ( 1 ) &gt; cond do ...(1)&gt; x == y -&gt; { :cont , { x , a - b } } ...(1)&gt; true -&gt; { :stop , nil } ...(1)&gt; end ...(1)&gt; end ...(1)&gt; E . grouped_inject ( ...(1)&gt; [ { :a , 1 } , { :b , 2 } , { :b , 2 } , { :c , 2 } , { :c , 1 } , { :c , 1 } ] , ...(1)&gt; { :a , 43 } , sub_same , reverse : true ) [ a : 42 , b : 0 , c : 0 ]","ref":"ExAequo.Enum.html","title":"ExAequo.Enum","type":"module"},{"doc":"","ref":"ExAequo.Enum.html#t:grouped_accumulator/2","title":"ExAequo.Enum.grouped_accumulator/2","type":"type"},{"doc":"## All kind of File related stuff","ref":"ExAequo.File.html","title":"ExAequo.File","type":"module"},{"doc":"","ref":"ExAequo.File.html#files/1","title":"ExAequo.File.files/1","type":"function"},{"doc":"expands wc and zips each matching file into a list of {String.t, File.Stat.t}","ref":"ExAequo.File.html#files_with_stat/1","title":"ExAequo.File.files_with_stat/1","type":"function"},{"doc":"expands wc and zips each matching file into a list of {String.t, File.Stat.t} , then filters only the files from today","ref":"ExAequo.File.html#today/1","title":"ExAequo.File.today/1","type":"function"},{"doc":"","ref":"ExAequo.File.html#t:date_tuple/0","title":"ExAequo.File.date_tuple/0","type":"type"},{"doc":"","ref":"ExAequo.File.html#t:lstat_result/0","title":"ExAequo.File.lstat_result/0","type":"type"},{"doc":"","ref":"ExAequo.File.html#t:param_type/0","title":"ExAequo.File.param_type/0","type":"type"},{"doc":"","ref":"ExAequo.File.html#t:params_t/0","title":"ExAequo.File.params_t/0","type":"type"},{"doc":"Tools to facilitate dispatching on keyword parameters, used in contexts like the following @defaults [ a : 1 , b : false ] # Keyword or Map def some_fun ( ... , options \\ [ ] ) # options again can be a Keyword or Map { a , b } = tuple_from_params ( @defaults , options , [ :a , :b ] ) Merging defaults and actual parameters Its most useful feature is that you will get a map whatever the mixtures of maps and keywords the input was iex(0)&gt; merge_params ( [ ] ) %{ } iex(1)&gt; merge_params ( [ a : 1 ] , %{ b : 2 } ) %{ a : 1 , b : 2 } iex(2)&gt; merge_params ( %{ a : 1 } , [ a : 2 , b : 2 ] ) %{ a : 2 , b : 2 } Strict merging Not implemented yet Extracting params from the merged defaults and actuals iex(3)&gt; defaults = [ foo : false , depth : 3 ] ...(3)&gt; tuple_from_params ( defaults , %{ foo : true } , [ :foo , :depth ] ) { true , 3 } As defaults are required a missing parameter will raise an Error iex(4)&gt; try do ...(4)&gt; tuple_from_params ( [ ] , [ foo : 1 ] , [ :bar ] ) ...(4)&gt; rescue ...(4)&gt; KeyError -&gt; :caught ...(4)&gt; end :caught Alternatively on can extract a map iex(5)&gt; map_from_params ( [ ] , [ hello : &quot;world&quot; ] , [ :hello ] ) %{ hello : &quot;world&quot; }","ref":"ExAequo.KeywordParams.html","title":"ExAequo.KeywordParams","type":"module"},{"doc":"This is the 2 param form which is identical to an empty default map iex(6)&gt; map_from_params ( %{ a : 1 , b : 2 } , [ :a ] ) %{ a : 1 }","ref":"ExAequo.KeywordParams.html#map_from_params/2","title":"ExAequo.KeywordParams.map_from_params/2","type":"function"},{"doc":"","ref":"ExAequo.KeywordParams.html#map_from_params/3","title":"ExAequo.KeywordParams.map_from_params/3","type":"function"},{"doc":"","ref":"ExAequo.KeywordParams.html#merge_params/1","title":"ExAequo.KeywordParams.merge_params/1","type":"function"},{"doc":"","ref":"ExAequo.KeywordParams.html#merge_params/2","title":"ExAequo.KeywordParams.merge_params/2","type":"function"},{"doc":"This is the 2 param form which is identical to an empty default map iex(7)&gt; tuple_from_params ( %{ a : 1 , b : 2 } , [ :b , :a ] ) { 2 , 1 }","ref":"ExAequo.KeywordParams.html#tuple_from_params/2","title":"ExAequo.KeywordParams.tuple_from_params/2","type":"function"},{"doc":"","ref":"ExAequo.KeywordParams.html#tuple_from_params/3","title":"ExAequo.KeywordParams.tuple_from_params/3","type":"function"},{"doc":"","ref":"ExAequo.KeywordParams.html#t:date_tuple/0","title":"ExAequo.KeywordParams.date_tuple/0","type":"type"},{"doc":"","ref":"ExAequo.KeywordParams.html#t:lstat_result/0","title":"ExAequo.KeywordParams.lstat_result/0","type":"type"},{"doc":"","ref":"ExAequo.KeywordParams.html#t:param_type/0","title":"ExAequo.KeywordParams.param_type/0","type":"type"},{"doc":"","ref":"ExAequo.KeywordParams.html#t:params_t/0","title":"ExAequo.KeywordParams.params_t/0","type":"type"},{"doc":"Extending Elixir's Path module with some useful functions","ref":"ExAequo.Path.html","title":"ExAequo.Path","type":"module"},{"doc":"iex(0)&gt; base_name_without_ext(&quot;a/b/c.txt&quot;) &quot;c&quot; iex(1)&gt; base_name_without_ext(&quot;a/b/c.txt.eex&quot;) &quot;c.txt&quot; iex(2)&gt; base_name_without_ext(&quot;a/b/c&quot;) &quot;c&quot;","ref":"ExAequo.Path.html#base_name_without_ext/1","title":"ExAequo.Path.base_name_without_ext/1","type":"function"},{"doc":"iex(3)&gt; full_name_without_ext(&quot;a/b/c.txt&quot;) &quot;a/b/c&quot; iex(4)&gt; full_name_without_ext(&quot;a/b/c.txt.eex&quot;) &quot;a/b/c.txt&quot; iex(5)&gt; full_name_without_ext(&quot;a/b/c&quot;) &quot;a/b/c&quot; iex(6)&gt; full_name_without_ext(&quot;/c&quot;) &quot;/c&quot;","ref":"ExAequo.Path.html#full_name_without_ext/1","title":"ExAequo.Path.full_name_without_ext/1","type":"function"},{"doc":"","ref":"ExAequo.Path.html#t:date_tuple/0","title":"ExAequo.Path.date_tuple/0","type":"type"},{"doc":"","ref":"ExAequo.Path.html#t:lstat_result/0","title":"ExAequo.Path.lstat_result/0","type":"type"},{"doc":"","ref":"ExAequo.Path.html#t:param_type/0","title":"ExAequo.Path.param_type/0","type":"type"},{"doc":"","ref":"ExAequo.Path.html#t:params_t/0","title":"ExAequo.Path.params_t/0","type":"type"},{"doc":"","ref":"ExAequo.SysInterface.Behavior.html","title":"ExAequo.SysInterface.Behavior","type":"behaviour"},{"doc":"","ref":"ExAequo.SysInterface.Behavior.html#c:expand_path/1","title":"ExAequo.SysInterface.Behavior.expand_path/1","type":"callback"},{"doc":"","ref":"ExAequo.SysInterface.Behavior.html#c:lstat/2","title":"ExAequo.SysInterface.Behavior.lstat/2","type":"callback"},{"doc":"","ref":"ExAequo.SysInterface.Behavior.html#c:wildcard/2","title":"ExAequo.SysInterface.Behavior.wildcard/2","type":"callback"},{"doc":"","ref":"ExAequo.SysInterface.Behavior.html#t:date_tuple/0","title":"ExAequo.SysInterface.Behavior.date_tuple/0","type":"type"},{"doc":"","ref":"ExAequo.SysInterface.Behavior.html#t:lstat_result/0","title":"ExAequo.SysInterface.Behavior.lstat_result/0","type":"type"},{"doc":"","ref":"ExAequo.SysInterface.Behavior.html#t:param_type/0","title":"ExAequo.SysInterface.Behavior.param_type/0","type":"type"},{"doc":"","ref":"ExAequo.SysInterface.Behavior.html#t:params_t/0","title":"ExAequo.SysInterface.Behavior.params_t/0","type":"type"},{"doc":"","ref":"ExAequo.SysInterface.Implementation.html","title":"ExAequo.SysInterface.Implementation","type":"module"},{"doc":"Callback implementation for ExAequo.SysInterface.Behavior.expand_path/1 .","ref":"ExAequo.SysInterface.Implementation.html#expand_path/1","title":"ExAequo.SysInterface.Implementation.expand_path/1","type":"function"},{"doc":"Callback implementation for ExAequo.SysInterface.Behavior.lstat/2 .","ref":"ExAequo.SysInterface.Implementation.html#lstat/2","title":"ExAequo.SysInterface.Implementation.lstat/2","type":"function"},{"doc":"Callback implementation for ExAequo.SysInterface.Behavior.wildcard/2 .","ref":"ExAequo.SysInterface.Implementation.html#wildcard/2","title":"ExAequo.SysInterface.Implementation.wildcard/2","type":"function"},{"doc":"","ref":"ExAequo.SysInterface.Implementation.html#t:date_tuple/0","title":"ExAequo.SysInterface.Implementation.date_tuple/0","type":"type"},{"doc":"","ref":"ExAequo.SysInterface.Implementation.html#t:lstat_result/0","title":"ExAequo.SysInterface.Implementation.lstat_result/0","type":"type"},{"doc":"","ref":"ExAequo.SysInterface.Implementation.html#t:param_type/0","title":"ExAequo.SysInterface.Implementation.param_type/0","type":"type"},{"doc":"","ref":"ExAequo.SysInterface.Implementation.html#t:params_t/0","title":"ExAequo.SysInterface.Implementation.params_t/0","type":"type"},{"doc":"","ref":"ExAequo.Types.html","title":"ExAequo.Types","type":"module"}]